import sys
import re

line = sys.stdin.readline()
assert re.match('[1-9][0-9]* [1-9][0-9]*\n', line)
n,p = map(int, line.strip().split())

assert 1 <= n <= 200000
assert 1 <= p <= 200000

line = sys.stdin.readline()
assert re.match('(0|[1-9][0-9]*)( [1-9][0-9]*)*\n', line)
ds = map(int, line.strip().split())
assert len(ds) == n
for d in ds:
    assert 0 <= d <= 1000000

for (d1,d2) in zip(ds, ds[1:]):
    assert d1 < d2

assert not sys.stdin.read()
sys.exit(42)

