import java.io.*
import java.util.*

fun main(args: Array<String>) {
    val sc = Scanner(System.`in`)
    val numDays = sc.nextInt()
    val numPayedDays = sc.nextInt()
    var previous = -2 * numPayedDays
    var streakStart = previous
    val payedDays = LinkedList<Int>()
    for (i in 0 until numPayedDays) {
        payedDays.addLast(streakStart)
    }

    var maxi = 0
    for (i in 0 until numDays) {
        val tmp = sc.nextInt()
        if (tmp == previous + 1) {
            // extend the current streak for free
        } else {
            val gap = tmp - previous - 1
            if (gap <= numPayedDays) {
                // gap can be filled completely
                for (j in 0 until gap) {
                    val first = payedDays.pollFirst()
                    payedDays.addLast(tmp - gap + j)
                    streakStart = first + 1
                }
            } else {
                // gap is too large
                payedDays.clear()
                for (j in 0 until numPayedDays) payedDays.addLast(tmp - numPayedDays + j)
                streakStart = tmp - numPayedDays
            }
        }
        maxi = Math.max(maxi, tmp - streakStart + 1)
        previous = tmp
    }
    System.out.println(maxi)
}
