// Author Alexander Rass
#include <bits/stdc++.h>
using namespace std;
// TODO minimal N=2??
const int MAXN = 512;
int num_edges[MAXN][MAXN];
int dp[MAXN][MAXN];
int best_choice[MAXN][MAXN];
int query(int x_lo,int x_hi, int y_lo, int y_hi){
    --x_lo;--x_hi;--y_lo;--y_hi;
    return num_edges[x_hi][y_hi] - num_edges[x_hi][y_lo] - num_edges[x_lo][y_hi] + num_edges[x_lo][y_lo];
}
int h[MAXN];
int calc_h(int f, int t){
    if(f + 1 == t){
        return 0;
    } else {
        int m = best_choice[f][t];
        int maxh = max(calc_h(f,m), calc_h(m,t));
        return h[m] = maxh + 1;
    }
}
int main(){
    int N,M;
    cin >>N >> M;
    memset(num_edges,0,sizeof(num_edges));
    for(int i = 0; i < M; i++){
        int a,b;
        cin >> a >> b;
        if(a > b)swap(a,b);
        assert(a != b);
        num_edges[a][b]++;
    }
    for(int i = 0; i <= N+4; i++) for(int j = 0; j < N+4; j++){
        if(i == 0 || j == 0)num_edges[i][j] = 0;
        else num_edges[i][j] += num_edges[i-1][j] + num_edges[i][j-1] - num_edges[i-1][j-1];
    }
    for(int i = 1; i < N; i++){
        dp[i][i+1] = query(0,i+1,i+1,i+2);
        best_choice[i][i+1] = -1;
    }
    for(int len = 2; len < N; len++){
        for(int i = 1; i + len <= N; i++){
            int j = i+len;
            dp[i][j] = 1e9; 
            for(int m = i+1; m < j; m++){
                int cur = query(0,m,m+1,j) + query(i+1,m,j,N+2) + dp[i][m] + dp[m][j];
                if(cur < dp[i][j]){
                    dp[i][j] = cur;
                    best_choice[i][j] = m;
                }
            }
        }
    }
    cout << dp[1][N] << endl;
    auto maxh = calc_h(1,N);
    h[1] = h[N] = maxh + 1;
    for(int i = 1; i <= N; i++)cout << h[i] << ((i==N)?'\n':' ');
	return 0;
}
