import java.util.StringTokenizer;
import java.io.BufferedReader;
import java.io.BufferedOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.OutputStream;

public class per {
    static int n, t;
    static int T[][], TC[][], cost[][], back[][];

    static int Cost(int l, int r) {
        if (r - l == 1) return 0;
        if (cost[l][r] == 0) {
            int res = 1<<30;
            for (int m = l+1; m < r; ++m) {
                int v = TC[l][m] + TC[m][r] - 2*TC[l][r] + Cost(l, m) + Cost(m, r);
                if (v < res) {
                    res = v;
                    back[l][r] = m;
                }
            }
            cost[l][r] = res+1;
        }
        return cost[l][r]-1;
    }

    static void Make(int l, int r, int H[]) {
        if (r - l > 1) {
            int m = back[l][r];
            H[m] = Math.min(H[l], H[r]) - 1;
            Make(l, m, H);
            Make(m, r, H);
        }
    }

    public static void main(String args[]) {
        Kattio io = new Kattio(System.in);
        n = io.getInt();
        t = io.getInt();
        T = new int[n+1][n+1];
        TC = new int[n+1][n+2];
        cost = new int[n+1][n+1];
        back = new int[n+1][n+1];
        for (int i = 0; i < t; ++i) {
            int a = io.getInt(), b = io.getInt();
            ++T[Math.min(a, b)][Math.max(a, b)];
        }
        for (int l = 1; l <= n; ++l)
            for (int r = n; r > l; --r)
                TC[l][r] = TC[l-1][r] + TC[l][r+1] - TC[l-1][r+1] + T[l][r];
        io.println(Cost(1, n) + T[1][n]);
        int H[] = new int[n+1];
        H[1] = H[n] = n;
        Make(1, n, H);
        for (int i = 1; i <= n; ++i)
            io.print(H[i] + (i == n ? "\n" : " "));
        io.flush();
    }
}


/** Simple yet moderately fast I/O routines.
 *
 * Example usage:
 *
 * Kattio io = new Kattio(System.in, System.out);
 *
 * while (io.hasMoreTokens()) {
 *    int n = io.getInt();
 *    double d = io.getDouble();
 *    double ans = d*n;
 *
 *    io.println("Answer: " + ans);
 * }
 *
 * io.close();
 *
 *
 * Some notes:
 *
 * - When done, you should always do io.close() or io.flush() on the
 *   Kattio-instance, otherwise, you may lose output.
 *
 * - The getInt(), getDouble(), and getLong() methods will throw an
 *   exception if there is no more data in the input, so it is generally
 *   a good idea to use hasMoreTokens() to check for end-of-file.
 *
 * @author: Kattis
 */

class Kattio extends PrintWriter {
    public Kattio(InputStream i) {
        super(new BufferedOutputStream(System.out));
        r = new BufferedReader(new InputStreamReader(i));
    }
    public Kattio(InputStream i, OutputStream o) {
        super(new BufferedOutputStream(o));
        r = new BufferedReader(new InputStreamReader(i));
    }

    public boolean hasMoreTokens() {
        return peekToken() != null;
    }

    public int getInt() {
        return Integer.parseInt(nextToken());
    }

    public double getDouble() {
        return Double.parseDouble(nextToken());
    }

    public long getLong() {
        return Long.parseLong(nextToken());
    }

    public String getWord() {
        return nextToken();
    }



    private BufferedReader r;
    private String line;
    private StringTokenizer st;
    private String token;

    private String peekToken() {
        if (token == null)
            try {
                while (st == null || !st.hasMoreTokens()) {
                    line = r.readLine();
                    if (line == null) return null;
                    st = new StringTokenizer(line);
                }
                token = st.nextToken();
            } catch (IOException e) { }
        return token;
    }

    private String nextToken() {
        String ans = peekToken();
        token = null;
        return ans;
    }
}
