#include <iostream>
#include <list>

using namespace std;
list<int> payedDays;
int numDays, numPayedDays, tmp, maxi, previous, streakStart;

int main() {
	cin >> numDays >> numPayedDays;
	previous = streakStart = -2 * numPayedDays;
	for (int i = 0; i < numPayedDays; i++) payedDays.push_back(-2*numPayedDays);
	for (int i = 0; i < numDays; i++) {
		cin >> tmp;
		if (tmp == previous + 1) {
			// extend the current streak for free
		} else {
			int gap = tmp - previous - 1;
			if (gap <= numPayedDays) {
				// gap can be filled completely
				for (int j = 0; j < gap; j++) {
					int first = payedDays.front();
					payedDays.pop_front();
					payedDays.push_back(tmp - gap + j);
					streakStart = first + 1;
				}
			} else {
				// gap is too large
				payedDays.clear();
				for (int j = 0; j < numPayedDays; j++) payedDays.push_back(tmp - numPayedDays + j);
				streakStart = tmp - numPayedDays;
			}
		}
		maxi = max(maxi, tmp - streakStart + 1);
		previous = tmp;
	}
	cout << maxi << endl;

	return 0;
}
