size(1000);
defaultpen(4);
bbox(white, Fill);

pen bluepen = rgb(0, 0, 1);
pen redpen = rgb(1, 0, 0);

void draw_box(pair coord, pen boxpen, real size) {
  fill((coord.x-size,coord.y-size)--(coord.x-size,coord.y+size)--(coord.x+size,coord.y+size)--(coord.x+size,coord.y-size)--cycle,boxpen);
}

int n = stdin;
int p = stdin;
int brk = stdin;
int start = stdin;
for (int i = 0; i < n; ++i) {
  int xCoord = stdin;
  int yCoord = (int)(xCoord/brk);
  xCoord = xCoord - (brk * yCoord);
  pair coord = (xCoord, yCoord);
  draw_box(coord, bluepen, 0.4);
}
int len = stdin;
for (int i = 0; i < len; ++i) {
   int xCoord = start + i;
  int yCoord = (int)(xCoord/brk);
  xCoord = xCoord - (brk * yCoord);
  pair coord = (xCoord, yCoord);
  draw_box(coord, redpen, 0.2);
}

shipout(bbox(xmargin=10, white, Fill));
