size(1000);
defaultpen(1);
bbox(white, Fill);

int n = stdin;
int t = stdin;
int T[][] = array(n+1, array(n+1, 0));

for (int i = 0; i < t; ++i) {
  int a = stdin, b = stdin;
  ++T[min(a, b)][max(a, b)];
}
int maxT = 0, maxTfreq = 0;
for (int i = 1; i <= n; ++i)
  for (int j = i+1; j <= n; ++j) {
    if (T[i][j] > maxT) {
      maxT = T[i][j];
      maxTfreq = 0;
    }
    if (T[i][j] == maxT)
      ++maxTfreq;
  }
write("(max_T, freq) = ", maxT, maxTfreq);

for (int i = 1; i <= n; ++i) {
  for (int j = i+1; j <= n; ++j) {
    if (T[i][j] == 0) continue;
    real c = 0.9-0.9*T[i][j] / maxT;
    fill((j-1, n-i)--(j,n-i)--(j,n-i+1)--(j-1,n-i+1)--cycle, p=rgb(c, c, c));
  }
}
draw((-0.1, -0.1)--(n+0.1,-0.1)--(n+0.1,n+0.1)--(-0.1,n+0.1)--cycle,p=defaultpen+0.5);

int cost = stdin;

int H[] = array(n+1, 0), minh = 10000000, maxh = 0;
for (int i = 1; i <= n; ++i) {
  H[i] = stdin;
  minh = min(minh, H[i]);
  maxh = max(maxh, H[i]);
}
int base = -3 - (maxh-minh+1);
for (int i = 1; i <= n; ++i) {
  fill((i-1+0.05, base)--(i-1+0.05,base+1+H[i]-minh)--(i-0.05,base+1+H[i]-minh)--(i-0.05,base)--cycle, darkgreen);
}

shipout(bbox(xmargin=10, white, Fill));
