#include <bits/stdc++.h>
using namespace std;

const int N = 510, oo = 0x3f3f3f3f;
int n;
int trips[N][N], dp[N][N], best[N][N], ans[N];

int count(int a, int b, int c, int d) {
	if (a >= b || c >= d) return 0;
	return trips[a][c] - trips[a][d] - trips[b][c] + trips[b][d];
}

int rec(int i, int j) {
	if (i == j) return 0;

	int &res = dp[i][j];
	if (res < oo) return res;
	
	for (int k = i; k < j; k++) {
		int cur = rec(i,k) + rec(k+1,j);
		cur += count(i,k,k,n) + count(0,k+1,k+1,j);
		if (cur < res) {
			res = cur;
			best[i][j] = k;
		}
	}
	return res;
}

void rec(int i, int j, int h) {
	if (i == j) return;
	int k = best[i][j];
	ans[k] = h;
	rec(i,k,h-1), rec(k+1,j,h-1);
}

int main() {
	int m; cin >> n >> m;
	while (m--) {
		int a, b; cin >> a >> b;
		if (a > b) swap(a,b);
		trips[a][b]++;
	}
	
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= n; j++) {
			trips[i][j] += trips[i-1][j] + trips[i][j-1] - trips[i-1][j-1];
		}
	}
	
	memset(dp,0x3f,sizeof dp);
	int res = rec(0,n);
	rec(0,n,N);

	cout << res << endl;
	for (int i = 0; i < n; i++) cout << ans[i] << " ";
	cout << endl;
}
