#include <bits/stdc++.h>
using namespace std;

// O(Choose(2N,N))

static int trees[1000];

vector<tuple<int,int,int>> todo;
void sow(int l,int r,int cur_height,function<void(void)> const &callback){
  stack<tuple<int,int,int>> undo;
  while (l==r and not todo.empty()){
    undo.emplace(todo.back());
    todo.pop_back();
    l=get<0>(undo.top());
    r=get<1>(undo.top());
    cur_height=get<2>(undo.top());
  }
  if (l==r){
    callback();
  }else{
    for (int i=l; i<r; i++){
      trees[i]=cur_height;
      todo.emplace_back(i+1,r,cur_height-1);
      sow(l,i,cur_height-1,callback);
      todo.pop_back();
    }
  }
  while (not undo.empty()){
    todo.emplace_back(undo.top());
    undo.pop();
  }
}

int main(){
  int n,m; cin>>n>>m;
  vector<pair<int,int>> paths(m);
  for (auto &i: paths){
    cin>>i.first>>i.second; --i.first, --i.second;
    if (i.second<i.first) swap(i.first,i.second);
  }

  int res=(1<<29);
  vector<int16_t> answer;
  sow(0,n,n,[&res,&answer,&paths,n](){
    int cost=0;
    for (auto path: paths){
      while (path.first!=path.second){
        int ngv=path.first+1;
        for (int i=path.first+2; i<=path.second; i++)
          if (trees[ngv]<trees[path.first] and trees[ngv]<trees[i])
            ngv=i;
        path.first=ngv;
        ++cost;
      }
    }
    if (cost<res){
      answer=vector<int16_t>(trees,trees+n);
      res=cost;
    }
  });

  cout<<res<<endl;

  int depth=(1<<29); for (int i: answer) depth=min(depth,i); for (auto &i: answer) i+=1-depth;
  for (int i=0; i<n; i++) cout<<answer[i]<<(i+1==n?'\n':' ');
}
