#include <bits/stdc++.h>
using namespace std;

int n, t;
int T[600][600] = {}, TC[600][600] = {};
int cost[600][600] = {-1}, back[600][600] = {};

int Cost(int l, int r) {
    if (r - l == 1) return 0;
    int &res = cost[l][r];
    if (res == -1) {
        res = 1<<30;
        for (int m = l+1; m < r; ++m) {
            int v = TC[l][m] + TC[m][r] - 2*TC[l][r] + Cost(l, m) + Cost(m, r);
            if (v < res) {
                res = v;
                back[l][r] = m;
            }
        }
    }
    return res;
}

void Make(int l, int r, vector<int> &H) {
    if (r - l > 1) {
        int m = back[l][r];
        H[m] = min(H[l], H[r]) - 1;
        Make(l, m, H);
        Make(m, r, H);
    }
}

int main(void) {
    scanf("%d%d", &n, &t);
    for (int i = 1; i < t; ++i) { // oops, only read t-1 journeys
        int a, b;
        scanf("%d%d", &a, &b);
        ++T[min(a, b)][max(a, b)];
    }
    for (int l = 1; l <= n; ++l)
        for (int r = n; r > l; --r)
            TC[l][r] = TC[l-1][r] + TC[l][r+1] - TC[l-1][r+1] + T[l][r];
    memset(cost, -1, sizeof(cost));
    vector<int> H(n+1, n);
    Cost(1, n);
    Make(1, n, H);

    // Somehow magically rediscover last journey to make sure reported cost is correct
    int a, b;
    scanf("%d%d", &a, &b);
    if (a > b) swap(a, b);
    int last_cost = 0;
    while (a < b) {
        int c = a+1;
        while (c < b && H[c] < H[a] && H[c] < H[b]) ++c;
        ++last_cost;
        a = c;
    }

    printf("%d\n", Cost(1, n) + T[1][n] + last_cost);
    for (int i = 1; i <= n; ++i)
        printf("%d%c", H[i], i==n ? '\n' : ' ');
    return 0;
}
